#ifndef ITERATIVE_EXTENSION_H
#define ITERATIVE_EXTENSION_H
#include <assert.h>
#ifdef MINIA_IS_IN_PARENT_FOLDER

#include "../minia/Utils.h"
#include "../minia/Terminator.h"
#include "../minia/Traversal.h"
#include "../minia/Kmer.h"
#include "../minia/Bank.h"
#include "../minia/Debloom.h"

#else

#include "minia/Utils.h"
#include "minia/Terminator.h"
#include "minia/Traversal.h"
#include "minia/Kmer.h"
#include "minia/Bank.h"
#include "minia/Debloom.h"

#endif

extern int64_t genome_size;
extern Bloom * bloo1;
extern BinaryBank * SolidKmers;
extern BranchingTerminator * terminator;
//Raluca
extern AssocPairedSet *pairedBranchingKmers ;


class IterativeExtensions {
    public:
        
    IterativeExtensions();
    static void construct_linear_seqs(string L,string R, int max_depth, string output_file, int verb, int  max_nodes);
    static void construct_linear_seqs(string L, int max_depth, string output_file);
    static void construct_linear_seqs_paired(string L,string R, int max_depth, string output_file , int verb, int max_nodes);
    static void construct_linear_seqs_paired(string L, int max_depth, string output_file);


    // controls behavior of construct_linear_seqs
    enum Traversal_type { SimplePaths, Monument };
    enum When_to_stop_extending { After_first_contig, Until_max_depth };
    static Traversal_type traversal_type; // initialized in .cpp
    static When_to_stop_extending when_to_stop_extending;    
    static bool dont_output_first_nucleotide;
    
    // extra function added by pierre
    static char * extend_a_snp(string L, int max_depth);
};

#endif
