#ifndef ASSERTS
#define NDEBUG // disable asserts, they're computationnally intensive
#endif

#include <stdio.h>
#include <assert.h>
#include <algorithm> // for min
#include "../minia/Kmer.h"
#include "Kmer_for_kissnp2.h"
#include "../minia/lut.h"

using namespace std;


kmer_type next_kmer_new(kmer_type graine, int added_nt, int strand)
{
    assert(added_nt<4);
    assert((strand == NULL) || (strand<2));

    kmer_type new_graine;
    kmer_type temp_graine;

    if (strand == 1)// the kmer we're extending is actually a revcomp sequence in the bidirected debruijn graph node
        temp_graine = revcomp(graine);
    else
        temp_graine = graine;

    new_graine = (((temp_graine) * 4 )  + added_nt) & kmerMask;
    //new_graine = (((graine) >> 2 )  + ( ((kmer_type)added_nt) << ((sizeKmer-1)*2)) ) & kmerMask; // previous kmer
    kmer_type revcomp_new_graine = revcomp(new_graine);

    return min(new_graine,revcomp_new_graine);
}

kmer_type next_kmer_new_norevcomp(kmer_type graine, int added_nt, int strand)
{
    assert(added_nt<4);
    assert((strand == NULL) || (strand<2));

    kmer_type new_graine;
    kmer_type temp_graine;

    if (strand == 1)// the kmer we're extending is actually a revcomp sequence in the bidirected debruijn graph node
        temp_graine = revcomp(graine);
    else
        temp_graine = graine;

    new_graine = (((temp_graine) * 4 )  + added_nt) & kmerMask;
    //new_graine = (((graine) >> 2 )  + ( ((kmer_type)added_nt) << ((sizeKmer-1)*2)) ) & kmerMask; // previous kmer
    kmer_type revcomp_new_graine = revcomp(new_graine);

    return new_graine;
}
